SystemOrganization addCategory: #'Compiler-Extensions'!

!BlockClosure methodsFor: '*Compiler-Extensions' stamp: 'EstebanAllende 12/6/2011 23:57'!
decompile
	^self method methodClass decompilerClass new decompileBlock: self! !

!AbstractTool methodsFor: '*Compiler-Extensions' stamp: 'EstebanAllende 12/23/2011 17:24'!
addClassIn: aPackage
	" add a new class in the provided package. A dialog will be opened to let the user set the class definition "

	| classSymbol systemCategory classDefinition |
	classSymbol := #NameOfSubclass.
	systemCategory := aPackage
		ifNil: [ 'Unknown' ].
	classDefinition := 'Object subclass: #' , classSymbol , '
		instanceVariableNames: '''' 
		classVariableNames: ''''
		poolDictionaries: ''''
		category: ''' , systemCategory name , ''''.
	classDefinition := UIManager default 
		multiLineRequest: 'Define class definition:'
		initialAnswer: classDefinition
		answerHeight: 250.
	(classDefinition isNil or: [ classDefinition isEmpty ])
		ifTrue: [ ^ self ].
	^EvaluateRequest evaluate: classDefinition.
! !

!AbstractTool methodsFor: '*Compiler-Extensions' stamp: 'EstebanAllende 12/23/2011 17:24'!
addTraitIn: aPackage
	" add a new class in the provided package. A dialog will be opened to let the user set the class definition "

	| classSymbol systemCategory classDefinition |
	classSymbol := #NameOfSubclass.
	systemCategory := aPackage
		ifNil: [ 'Unknown' ].
	classDefinition := 'Trait named: #TSortable
	uses: {}
	category: ''' , systemCategory name , ''''.
	classDefinition := UIManager default 
		multiLineRequest: 'Define class definition:'
		initialAnswer: classDefinition
		answerHeight: 250.
	(classDefinition isNil or: [ classDefinition isEmpty ])
		ifTrue: [ ^ self ].
	^EvaluateRequest evaluate: classDefinition.! !

!AbstractTool methodsFor: '*Compiler-Extensions' stamp: 'EstebanAllende 2/20/2012 23:26'!
compileANewClassFrom: aString notifying: aController startingFrom: aClass
	
	" Copied from Browser "
	
	"The receiver's textual content is a request to define a new class. The
	source code is defString. If any errors occur in compilation, notify
	aController."
	| oldClass class newClassName defTokens keywdIx envt |
	oldClass := aClass.
	defTokens := aString findTokens: Character separators.
	
	((defTokens first = 'Trait' and: [defTokens second = 'named:'])
		or: [defTokens second = 'classTrait'])
		ifTrue: [^ self defineTrait: aString notifying: aController ].
		
	keywdIx := defTokens findFirst: [:x | x beginsWith: 'category'].
	envt := Smalltalk globals.
	keywdIx := defTokens findFirst: [:x | '*subclass*' match: x].
	newClassName := (defTokens at: keywdIx+1) copyWithoutAll: '#()'.
	((oldClass isNil or: [oldClass theNonMetaClass name asString ~= newClassName])
		and: [envt includesKey: newClassName asSymbol]) ifTrue:
			["Attempting to define new class over existing one when
				not looking at the original one in this browser..."
			(self confirm: ((newClassName , ' is an existing class in this system.
Redefining it might cause serious problems.
Is this really what you want to do?') asText makeBoldFrom: 1 to: newClassName size))
				ifFalse: [^ nil]].
	"ar 8/29/1999: Use oldClass superclass for defining oldClass
	since oldClass superclass knows the definerClass of oldClass."
	oldClass ifNotNil:[oldClass := oldClass superclass].
	class := (EvaluateRequest new 
							source: aString;
							compileContext: oldClass compilerContext;
							requestor: aController;
							logged: true;
							yourself) processRequest.
	"class := oldClass subclassDefinerClass
				evaluate: aString
				notifying: aController
				logged: true."
	^ (class isKindOf: Behavior)
		ifTrue: [ class ]
		ifFalse: [ nil ]! !

!AbstractTool methodsFor: '*Compiler-Extensions' stamp: 'EstebanAllende 12/23/2011 17:27'!
defineTrait: defString notifying: aController  

	| defTokens keywdIx envt oldTrait newTraitName trait |
	oldTrait := self selectedClassOrMetaClass.
	defTokens := defString findTokens: Character separators.
	keywdIx := defTokens findFirst: [:x | x = 'category'].
	envt := self selectedEnvironment.
	keywdIx := defTokens findFirst: [:x | x = 'named:'].
	newTraitName := (defTokens at: keywdIx+1) copyWithoutAll: '#()'.
	((oldTrait isNil or: [oldTrait baseTrait name asString ~= newTraitName])
		and: [envt includesKey: newTraitName asSymbol]) ifTrue:
			["Attempting to define new class/trait over existing one when
				not looking at the original one in this browser..."
			(self confirm: ((newTraitName , ' is an existing class/trait in this system.
Redefining it might cause serious problems.
Is this really what you want to do?') asText makeBoldFrom: 1 to: newTraitName size))
				ifFalse: [^ nil ]].

	trait := (EvaluateRequest new source: defString; requestor: aController; logged: true) processRequest.
	^ (trait isKindOf: TraitBehavior)
		ifTrue: [
			self changed: #classList.
			self classListIndex: (self classList indexOf: trait baseTrait name).
			self clearUserEditFlag; editClass.
			trait]
		ifFalse: [ nil ]! !

!Browser methodsFor: '*Compiler-Extensions' stamp: 'EstebanAllende 2/20/2012 23:01'!
defineClass: defString notifying: aController  
	"The receiver's textual content is a request to define a new class. The
	source code is defString. If any errors occur in compilation, notify
	aController."
	| oldClass class newClassName defTokens keywdIx envt |
	oldClass := self selectedClassOrMetaClass.
	defTokens := defString findTokens: Character separators.
	
	((defTokens first = 'Trait' and: [defTokens second = 'named:'])
		or: [defTokens second = 'classTrait'])
		ifTrue: [^self defineTrait: defString notifying: aController].
		
	keywdIx := defTokens findFirst: [:x | x beginsWith: 'category'].
	envt := Smalltalk globals.
	keywdIx := defTokens findFirst: [:x | '*subclass*' match: x].
	newClassName := (defTokens at: keywdIx+1) copyWithoutAll: '#()'.
	((oldClass isNil or: [oldClass theNonMetaClass name asString ~= newClassName])
		and: [envt includesKey: newClassName asSymbol]) ifTrue:
			["Attempting to define new class over existing one when
				not looking at the original one in this browser..."
			(self confirm: ((newClassName , ' is an existing class in this system.
Redefining it might cause serious problems.
Is this really what you want to do?') asText makeBoldFrom: 1 to: newClassName size))
				ifFalse: [^ false]].
	"ar 8/29/1999: Use oldClass superclass for defining oldClass
	since oldClass superclass knows the definerClass of oldClass."
	oldClass ifNotNil:[oldClass := oldClass superclass].
	
	class := (EvaluateRequest new 
							source: defString;
							compileContext: oldClass compilerContext;
							requestor: aController;
							logged: true;
							yourself) processRequest.
"	class := oldClass subclassDefinerClass
				evaluate: defString
				notifying: aController
				logged: true."
	(class isKindOf: Behavior)
		ifTrue: [self changed: #systemCategoryList.
				self changed: #classList.
				self clearUserEditFlag.
				self setClass: class selector: nil.
				"self clearUserEditFlag; editClass."
				^ true]
		ifFalse: [^ false]! !

!Browser methodsFor: '*Compiler-Extensions' stamp: 'EstebanAllende 12/23/2011 17:27'!
defineTrait: defString notifying: aController  

	| defTokens keywdIx envt oldTrait newTraitName trait |
	oldTrait := self selectedClassOrMetaClass.
	defTokens := defString findTokens: Character separators.
	keywdIx := defTokens findFirst: [:x | x = 'category'].
	envt := self selectedEnvironment.
	keywdIx := defTokens findFirst: [:x | x = 'named:'].
	newTraitName := (defTokens at: keywdIx+1) copyWithoutAll: '#()'.
	((oldTrait isNil or: [oldTrait baseTrait name asString ~= newTraitName])
		and: [envt includesKey: newTraitName asSymbol]) ifTrue:
			["Attempting to define new class/trait over existing one when
				not looking at the original one in this browser..."
			(self confirm: ((newTraitName , ' is an existing class/trait in this system.
Redefining it might cause serious problems.
Is this really what you want to do?') asText makeBoldFrom: 1 to: newTraitName size))
				ifFalse: [^ false]].

	trait := (EvaluateRequest new source: defString; requestor: aController; logged: true) processRequest.
	^(trait isKindOf: TraitBehavior)
		ifTrue: [
			self changed: #classList.
			self classListIndex: (self classList indexOf: trait baseTrait name).
			self clearUserEditFlag; editClass.
			true]
		ifFalse: [ false ]
! !

!Behavior methodsFor: '*Compiler-Extensions' stamp: 'EstebanAllende 3/15/2012 11:22'!
subclassDefinerClass
	"Answer an evaluator class appropriate for evaluating definitions of new 
	subclasses of this class."
	"self deprecated: 'Use new evaluate request' on: 'December 23th, 2011' in: 'NCAPI'."
	^Compiler! !

!DigitalSignatureAlgorithm class methodsFor: '*Compiler-Extensions' stamp: 'EstebanAllende 12/23/2011 17:48'!
testExamplesFromDisk
	"verify messages from file on disk"
	"Note: Secure random numbers are needed for key generation and message signing, but not for signature verification. There is no need to call initRandomFromUser if you are merely checking a signature."
	"DigitalSignatureAlgorithm testExamplesFromDisk"

	FileStream 
		readOnlyFileNamed: 'dsa.test.out' 
		do: [ :file |
			| msg sig publicKey |
			[file atEnd] whileFalse: [
				sig := file nextChunk.
				msg := file nextChunk.
				publicKey := EvaluateRequest evaluate: file nextChunk.
				(self verify: sig isSignatureOf: msg publicKey: publicKey) 
					ifTrue: [Transcript show: 'SUCCESS: ',msg; cr.]
					ifFalse: [self error: 'ERROR!! Signature verification failed']]]! !

!DictionaryInspector methodsFor: '*Compiler-Extensions' stamp: 'EstebanAllende 12/23/2011 17:46'!
addEntry
	| newKey aKey |

	newKey := UIManager default request:
'Enter new key, then type RETURN.
(Expression will be evaluated for value.)
Examples:  #Fred    ''a string''   3+4'.
	aKey := EvaluateRequest evaluate: newKey.
	object at: aKey put: nil.
	self calculateKeyArray.
	selectionIndex := self numberOfFixedFields + (keyArray indexOf: aKey).
	self changed: #inspectObject.
	self changed: #selectionIndex.
	self changed: #fieldList.
	self update! !

!DictionaryInspector methodsFor: '*Compiler-Extensions' stamp: 'EstebanAllende 12/23/2011 17:47'!
renameEntry
	| newKey aKey value |

	value := object at: (keyArray at: selectionIndex - self numberOfFixedFields).
	newKey := UIManager default request: 
'Enter new key, then type RETURN.
(Expression will be evaluated for value.)
Examples:  #Fred    ''a string''   3+4'
		 initialAnswer: (keyArray at: selectionIndex - self numberOfFixedFields) printString.
	newKey isNil ifFalse: [
		aKey := EvaluateRequest evaluate: newKey.
		object removeKey: (keyArray at: selectionIndex - self numberOfFixedFields).
		object at: aKey put: value.
		self calculateKeyArray.
		selectionIndex := self numberOfFixedFields + (keyArray indexOf: aKey).
		self changed: #selectionIndex.
		self changed: #inspectObject.
		self changed: #fieldList.
		self update ]! !

!Class methodsFor: '*Compiler-Extensions' stamp: 'EstebanAllende 1/14/2013 18:16'!
duplicateClassWithNewName: aSymbol
	| copysName class newDefinition |
	copysName := aSymbol asSymbol.
	copysName = self name
		ifTrue: [ ^ self ].
	(Smalltalk globals includesKey: copysName)
		ifTrue: [ ^ self error: copysName , ' already exists' ].
	newDefinition := self definition copyReplaceAll: '#' , self name asString with: '#' , copysName asString.
	class := EvaluateRequest evaluateAndLog: newDefinition.
	class class instanceVariableNames: self class instanceVariablesString.
	class copyAllCategoriesFrom: self.
	class class copyAllCategoriesFrom: self class.
	^ class! !

!Debugger methodsFor: '*Compiler-Extensions' stamp: 'EstebanAllende 12/23/2011 17:43'!
returnValue
	"Force a return of a given value to the previous context!!"

	| previous selectedContext expression value |
	contextStackIndex = 0 ifTrue: [^Beeper beep].
	selectedContext := self selectedContext.
	expression := UIManager default request: 'Enter expression for return value:'.
	value := (EvaluateRequest new source: expression; runtimeContext: selectedContext; compileContext: nil class compilerContext) sendTo: selectedContext receiver.
	previous := selectedContext sender.
	self resetContext: previous.
	interruptedProcess popTo: previous value: value! !

!UndefinedObject methodsFor: '*Compiler-Extensions' stamp: 'EstebanAllende 2/20/2012 22:49'!
subclassDefinerClass
	"For disjunct class hierarchies -- how should subclasses of nil be evaluated"
	self deprecated: 'Use new evaluate request' on: 'December 23th, 2011' in: 'NCAPI'.
	^self class evaluatorClass! !

!TraitBehavior methodsFor: '*Compiler-Extensions' stamp: 'EstebanAllende 2/20/2012 22:49'!
subclassDefinerClass
	self deprecated: 'Use new evaluate request' on: 'December 23th, 2011' in: 'NCAPI'.
	^nil subclassDefinerClass ! !

!ChangeRecord methodsFor: '*Compiler-Extensions' stamp: 'EstebanAllende 12/23/2011 17:28'!
fileIn
	"File the receiver in.  If I represent a method or a class-comment, file the method in and make a note of it in the recent-submissions list; if I represent a do-it, then, well, do it."

	Cursor read
		showWhile: [ 
			| methodClass aSelector s |
			(methodClass := self methodClass) notNil
				ifTrue: [ 
					methodClass
						compile: self text
						classified: category
						withStamp: stamp
						notifying: nil.
					(aSelector := self methodSelector)
						ifNotNil: [ RecentMessageList uniqueInstance 
									addMethodReference: ((methodClass >> aSelector) methodReference )] ].
			type == #doIt
				ifTrue: [ 
					((s := self string) beginsWith: '----')
						ifFalse: [ EvaluateRequest evaluate: s] ].
			"This expression break the recentMessageSet because it hijacks compiled methods to represent classComment. In the future we should redo a complete changeset metamodel based on classDefinition, classComment and other. 
			type == #classComment
				ifTrue: [ 
					| cls |
					(cls := Smalltalk globals at: class asSymbol) comment: self text stamp: stamp.
					RecentMessageSet noteMethodSubmission: #Comment forClass: cls ]" ]! !

!SmalltalkEditor methodsFor: '*Compiler-Extensions' stamp: 'EstebanAllende 12/23/2011 16:45'!
evaluateSelectionAndDo: aBlock
	"Treat the current selection as an expression; evaluate it and invoke aBlock with the result."
	| result rcvr ctxt |

	self lineSelectAndEmptyCheck: [^ ''].
	(model respondsTo: #doItReceiver) 
		ifTrue: [ rcvr := model doItReceiver.
				ctxt := model doItContext]
		ifFalse: [ rcvr := ctxt := nil].
	result := [ |er|
		er := EvaluateRequest new.
		er source: self selection string.
		er runtimeContext: ctxt.
		er requestor: self morph.
		er failBlock: [self morph flash. ^nil].
		er logged: true.
		er sendTo: rcvr.
	] 
		on: OutOfScopeNotification 
		do: [ :ex | ex resume: true].
	^ aBlock value: result! !

!CodeHolder methodsFor: '*Compiler-Extensions' stamp: 'EstebanAllende 11/28/2011 00:31'!
validateMessageSource: sourceString forSelector: aSelector
	"Check whether there is evidence that method source is invalid"
	<deprecated: 'This method only support Smalltallk-80 source code'> "A pragma to not see many message"
	"| sourcesName request|"
	
"	request := MethodCompilerRequest new.
	request onlyParse: true.
	request source: sourceString.
	request failBlock: [:a :b| nil].
	request target: Object.
	((request processRequest) selector = aSelector)"
	true
		ifFalse: ["sourcesName := FileDirectory localNameFor: Smalltalk sourcesName."
			self inform: 'There may be a problem with your sources file!!

The source code for every method should (usually) start with the
method selector but this is not the case with this method!! You may
proceed with caution but it is recommended that you get a new source file.

This can happen if you download the "' , 'dummy' "sourcesName"  , '" file, 
or the ".changes" file you use, as TEXT. It must be transfered 
in BINARY mode, even if it looks like a text file, 
to preserve the CR line ends.

Mac users: This may have been caused by Stuffit Expander. 
To prevent the files above to be converted to Mac line ends 
when they are expanded, do this: Start the program, then 
from Preferences... in the File menu, choose the Cross 
Platform panel, then select "Never" and press OK. 
Then expand the compressed archive again.

(Occasionally, the source code for a method may legitimately
start with a non-alphabetic character -- for example, Behavior
method #formalHeaderPartsFor:.  In such rare cases, you can
happily disregard this warning.)'].! !

!CompiledMethod methodsFor: '*Compiler-Extensions' stamp: 'EstebanAllende 12/13/2011 14:23'!
debuggerMap
	^(self methodClass compilerContext compiler bcMethodMapper) forMethod: self! !

!CompiledMethod methodsFor: '*Compiler-Extensions' stamp: 'EstebanAllende 2/25/2013 11:40'!
parseTree
	|failBlock compileResult|
	failBlock := [^((MethodParseRequest new source: self sourceCode) sendTo: self methodClass) classBinding: self methodClass binding].
	compileResult := (MethodCompileRequest new 
		source: self sourceCode;
		trailer: self trailer;
		category: self category;
		failBlock: failBlock;
		target: self methodClass
	) processRequest.
	^compileResult node.
	
	! !

!TextEditor methodsFor: '*Compiler-Extensions' stamp: 'EstebanAllende 12/23/2011 16:49'!
evaluateSelectionAndDo: aBlock
	"Treat the current selection as an expression; evaluate it and invoke aBlock with the result."
	| result rcvr ctxt |
	self lineSelectAndEmptyCheck: [^ nil].

	(model respondsTo: #doItReceiver) 
		ifTrue: [ rcvr := model doItReceiver.
				ctxt := model doItContext]
		ifFalse: [rcvr := ctxt := nil].
	result := [ |er|
		er := EvaluateRequest new.
		er source: self selection string.
		er runtimeContext: ctxt.
		er requestor: self.
		er failBlock: [morph flash. ^nil].
		er logged: true.
		er sendTo: rcvr.
	] 
		on: OutOfScopeNotification 
		do: [ :ex | ex resume: true].
	^aBlock value: result! !

!FileContentsBrowser methodsFor: '*Compiler-Extensions' stamp: 'EstebanAllende 12/23/2011 18:19'!
selectedBytecodes
	"Compile the source code for the selected message selector and extract and return
	the bytecode listing."
	| class selector |
	self flag: #DEAD.
	class := self selectedClassOrMetaClass.
	selector := self selectedMessageName.
	contents := class sourceCodeAt: selector.
	contents := (MethodCompileRequest new source: contents; trailer: CompiledMethodTrailer empty) sendTo: class.
	"contents := self class evaluatorClass new
					parse: contents
					in: class
					notifying: nil.
	contents := contents generate."
	^ contents symbolic asText! !

!SHTextStylerST80 class methodsFor: '*Compiler-Extensions' stamp: 'EstebanAllende 11/29/2011 17:08'!
attributeArrayForColor: aColorOrNil emphasis: anEmphasisSymbolOrArrayorNil font: aTextStyleOrFontOrNil 
	| emphArray answer |
	self deprecated: 'Method now in StyleTable' on: 'November 29, 2011' in: 'New Compiler API 0.2'.
	answer := Array new.
	aColorOrNil
		ifNotNil: [answer := answer , {TextColor color: aColorOrNil}].
	anEmphasisSymbolOrArrayorNil
		ifNotNil: [emphArray := anEmphasisSymbolOrArrayorNil isSymbol
						ifTrue: [{anEmphasisSymbolOrArrayorNil}]
						ifFalse: [anEmphasisSymbolOrArrayorNil].
			emphArray
				do: [:each | each ~= #normal
						ifTrue: [answer := answer , {TextEmphasis perform: each}]]].
	aTextStyleOrFontOrNil
		ifNotNil: [answer := answer , {TextFontReference toFont: aTextStyleOrFontOrNil}].
	^ answer! !

!SHTextStylerST80 class methodsFor: '*Compiler-Extensions' stamp: 'EstebanAllende 11/29/2011 16:17'!
attributesFor: aSymbol pixelHeight: aNumber 
	self deprecated: 'Method now in StyleTable' on: 'November 29, 2011' in: 'New Compiler API 0.2'.
	^ (self textAttributesByPixelHeight
		at: aNumber
		ifAbsentPut: [self initialTextAttributesForPixelHeight: aNumber])
		at: aSymbol
		ifAbsent: []! !

!SHTextStylerST80 class methodsFor: '*Compiler-Extensions' stamp: ''!
attributesFor: aSymbol pixelHeight: aNumber inCompilerContext: aCompilerContext
	|res|
	res := styleTableObject attributesFor: aSymbol pixelHeight: aNumber.
	res ifNil:[
		res := aCompilerContext styler methodStyler styleTable attributesFor: aSymbol  pixelHeight: aNumber
	].
	^res.
	
	"^ (self textAttributesByPixelHeight
		at: aNumber
		ifAbsentPut: [self initialTextAttributesForPixelHeight: aNumber])
		at: aSymbol
		ifAbsent: []"! !

!SHTextStylerST80 class methodsFor: '*Compiler-Extensions' stamp: 'EstebanLorenzano 10/16/2012 14:25'!
defaultStyleTable
	"color can be a valid argument to Color class>>colorFrom: , or nil to
	use the editor text color.
	Multiple emphases can be specified using an array e.g. #(bold italic).
	If emphasis is not specified, #normal will be used.
	if pixel height is not specified , then the editor font size will be used.
	"
								
 	^ self blueStyleTable! !

!SHTextStylerST80 class methodsFor: '*Compiler-Extensions' stamp: 'EstebanAllende 11/29/2011 17:10'!
initialTextAttributesForPixelHeight: aNumber 
	| d |
	self deprecated: 'Method now in StyleTable' on: 'November 29, 2011' in: 'New Compiler API 0.2'.
	d := IdentityDictionary new.
	self styleTable
		do: [:each | 
			| textStyle element emphasis font pixelHeight attrArray color textStyleName |
			element := each first.
			color := each
						at: 2
						ifAbsent: [].
			color := color
						ifNotNil: [Color colorFrom: color].
			emphasis := each
						at: 3
						ifAbsent: [].
			textStyleName := each
						at: 4
						ifAbsent: [].
			pixelHeight := each
						at: 5
						ifAbsent: [aNumber].
			textStyleName
				ifNil: [pixelHeight := nil].
			textStyle := TextStyle named: textStyleName.
			font := textStyle
						ifNotNil: [pixelHeight
								ifNotNil: [textStyle fontOfSize: pixelHeight]].
			attrArray := self
						attributeArrayForColor: color
						emphasis: emphasis
						font: font.
			attrArray notEmpty
				ifTrue: [d at: element put: attrArray]].
	^ d! !

!SHTextStylerST80 class methodsFor: '*Compiler-Extensions' stamp: 'EstebanAllende 11/29/2011 16:53'!
initialize
	"self initialize"
	styleTable := nil.
	textAttributesByPixelHeight := nil.
	(self class hasInstVarNamed: #styleTableObject) ifFalse: [self class addInstVarNamed: #styleTableObject].
	self instVarNamed: #styleTableObject put: (StyleTable for: self).
	(PluggableTextMorph respondsTo: #stylingClass:)
		ifTrue: [ PluggableTextMorph stylingClass: self ]! !

!SHTextStylerST80 class methodsFor: '*Compiler-Extensions' stamp: ''!
styleArray
	^ styleTable
		ifNil: [styleTable := self defaultStyleTable]! !

!SHTextStylerST80 class methodsFor: '*Compiler-Extensions' stamp: 'EstebanAllende 1/14/2013 19:32'!
styleTable: anArray 
	styleTable := anArray.
	textAttributesByPixelHeight := nil.
	ACCompilerContext initialize.! !

!SHTextStylerST80 class methodsFor: '*Compiler-Extensions' stamp: 'EstebanAllende 11/29/2011 17:10'!
textAttributesByPixelHeight
	self deprecated: 'Method now in StyleTable' on: 'November 29, 2011' in: 'New Compiler API 0.2'.
	^ textAttributesByPixelHeight
		ifNil: [textAttributesByPixelHeight := Dictionary new]! !

!SHTextStylerST80 methodsFor: '*Compiler-Extensions' stamp: 'EstebanAllende 11/29/2011 15:41'!
attributesFor: aSymbol 
	^ self class attributesFor: aSymbol pixelHeight: self pixelHeight inCompilerContext: classOrMetaClass compilerContext! !

!SHTextStylerST80 methodsFor: '*Compiler-Extensions' stamp: 'EstebanAllende 11/29/2011 23:45'!
rangesIn: aText setWorkspace: aBoolean

	^classOrMetaClass compilerContext  styler methodStyler
		rangeSyntaxAttributesFor: aText asString
		in: classOrMetaClass
		workspace: (aBoolean
				ifTrue: [workspace])
		env: environment! !

!TPureBehavior methodsFor: '*Compiler-Extensions' stamp: 'EstebanAllende 12/23/2011 14:58'!
compile: code classified: category notifying: requestor trailer: bytes ifFail: failBlock
	"Compile code without logging the source in the changes file"

	|request methodNode |
	request := MethodCompileRequest new.
	request source: code.
	request category: category.
	request requestor: requestor.
	request trailer: bytes.
	request failBlock: failBlock.
	^request sendTo: self. 
	! !

!TPureBehavior methodsFor: '*Compiler-Extensions' stamp: 'EstebanAllende 4/3/2013 14:23'!
compile: code notifying: requestor 
	"Compile the argument, code, as source code in the context of the 
	receiver and insEtall the result in the receiver's method dictionary. The 
	second argument, requestor, is to be notified if an error occurs. The 
	argument code is either a string or an object that converts to a string or 
	a PositionableStream. This method also saves the source code."
	
	| methodAndNode |
	methodAndNode  := self
		compile: code "a Text"
		classified: nil
		notifying: requestor
		trailer: self defaultMethodTrailer
		ifFail: [^nil].
	methodAndNode method putSource: code fromParseNode: methodAndNode node inFile: 2
			withPreamble: [:f | f cr; nextPut: $!!; nextChunkPut: 'Behavior method'; cr].
	self addSelector: methodAndNode selector withMethod: methodAndNode method notifying: requestor.
	methodAndNode results withIndexDo: [ :each :i|
		(i == 1)
			ifFalse: [ self addSelector: each selector withMethod: each method ]
	 ].
	^ methodAndNode selector! !

!TPureBehavior methodsFor: '*Compiler-Extensions' stamp: 'EstebanAllende 11/27/2011 15:49'!
compilerClass
	"Answer a compiler class appropriate for source methods of this class."

	^self compilerContext compiler bcCompilerClass! !

!TPureBehavior methodsFor: '*Compiler-Extensions' stamp: 'EstebanAllende 11/27/2011 14:05'!
decompilerClass
	"Answer a decompiler class appropriate for compiled methods of this class."

	^ self compilerContext compiler bcDecompilerClass! !

!TPureBehavior methodsFor: '*Compiler-Extensions' stamp: 'EstebanAllende 3/15/2012 11:21'!
evaluatorClass
	"Answer an evaluator class appropriate for evaluating expressions in the 
	context of this class."
	"self deprecated: 'Use new evaluate request' on: 'Dicember 23th, 2011' in: 'NCAPI'." 
	^self compilerContext compiler bcEvaluatorClass! !

!TPureBehavior methodsFor: '*Compiler-Extensions' stamp: 'EstebanAllende 12/23/2011 14:56'!
firstPrecodeCommentFor:  selector
	"If there is a comment in the source code at the given selector that preceeds the body of the method, return it here, else return nil"

	| parser source tree request|
	"Behavior firstPrecodeCommentFor: #firstPrecodeCommentFor:"
	(#(Comment Definition Hierarchy) includes: selector)
		ifTrue:
			["Not really a selector"
			^ nil].
	source := self sourceCodeAt: selector asSymbol ifAbsent: [^ nil].
	tree := (MethodParseRequest new source: source) sendTo: self.
	"parser := self parserClass new.
	tree := 
		parser
			parse: source readStream
			class: self
			noPattern: false
			context: nil
			notifying: nil
			ifFail: [^ nil]."
	^ (tree comment ifNil: [^ nil]) first! !

!TPureBehavior methodsFor: '*Compiler-Extensions' stamp: 'EstebanAllende 12/23/2011 14:56'!
formalParametersAt: aSelector
	"Return the names of the arguments used in this method."

	| source request node|
	source := self sourceCodeAt: aSelector ifAbsent: [^ #()].	"for now"
	node := (MethodParseRequest new source: source) sendTo: self.
	^node arguments ifNil: [#()] ifNotNil: [node arguments collect: [:each| each name]]! !

!TPureBehavior methodsFor: '*Compiler-Extensions' stamp: 'EstebanAllende 12/23/2011 14:56'!
methodHeaderFor: selector 
	"Answer the string corresponding to the method header for the given selector"

	| sourceString request methodNode|
	sourceString := self ultimateSourceCodeAt: selector ifAbsent: [self standardMethodHeaderFor: selector].
	methodNode := (MethodParseRequest new source: sourceString) sendTo: self.
	^sourceString asString copyFrom: 1 to: ((methodNode arguments size >0) ifTrue:[methodNode arguments last stop] ifFalse:[methodNode selectorParts first stop]).
"	(parser := self parserClass new) parseSelector: sourceString.
	^ sourceString asString copyFrom: 1 to: (parser endOfLastToken min: sourceString size)"

	"Behavior methodHeaderFor: #methodHeaderFor: "
! !

!TPureBehavior methodsFor: '*Compiler-Extensions' stamp: 'EstebanAllende 11/27/2011 15:46'!
oldCompilerClass
	"Answer a compiler class appropriate for source methods of this class."

	^self compilerContext compiler bcCompilerClass! !

!TPureBehavior methodsFor: '*Compiler-Extensions' stamp: 'EstebanAllende 11/27/2011 14:10'!
parserClass
	"Answer a parser class to use for parsing method headers."

	^self compilerContext compiler bcParserClass! !

!TPureBehavior methodsFor: '*Compiler-Extensions' stamp: 'EstebanAllende 4/3/2013 14:25'!
recompile: selector from: oldClass
	"Compile the method associated with selector in the receiver's method dictionary."
	"ar 7/10/1999: Use oldClass compiledMethodAt: not self compiledMethodAt:"
	| method methodNode request pair ctx|
	request := MethodCompileRequest new.
	request source: (oldClass sourceCodeAt: selector).
	request failBlock: [^ self]. "Assume OK after proceed from SyntaxError"
	request trailer: (oldClass compiledMethodAt: selector) trailer.
	request target: self.
	ctx := CompilerFrontend compilerContextForClass: oldClass.
	pair := ctx compiler methodCompiler compileWithRequest: request usingCompilerContext: ctx.
	methodNode := pair node. 
	selector == methodNode selector ifFalse: [self error: 'selector changed!!'].
	"fake"pair results do: [ :p|
		self basicAddSelector: p selector withMethod: p method.
	]
! !

!TPureBehavior methodsFor: '*Compiler-Extensions' stamp: 'EstebanAllende 12/23/2011 14:58'!
recompileNonResidentMethod: method atSelector: selector from: oldClass
	"Recompile the method supplied in the context of this class."

	|methodNode request pair|
	request := MethodCompileRequest new.
	request source: (method getSourceFor: selector in: oldClass).
	request failBlock: ["We're in deep doo-doo if this fails (syntax error).
				Presumably the user will correct something and proceed,
				thus installing the result in this methodDict.  We must
				retrieve that new method, and restore the original (or remove)
				and then return the method we retrieved."
				^ self error: 'see comment'].
	request trailer: method trailer.
	pair := request sendTo: self.
	methodNode := pair node    
	selector == methodNode selector ifFalse: [self error: 'selector changed!!'].
	^pair method.
! !

!TPureBehavior methodsFor: '*Compiler-Extensions' stamp: 'al 9/16/2005 14:17'!
sourceCodeTemplate
	"Answer an expression to be edited and evaluated in order to define 
	methods in this class or trait."

	^'message selector and argument names
	"comment stating purpose of message"

	| temporary variable names |
	statements'! !

!ChangeList methodsFor: '*Compiler-Extensions' stamp: 'EstebanAllende 12/23/2011 17:27'!
selectSuchThat
	"query the user for a selection criterium.  NB: the UI for invoking this from a changelist browser is currently commented out; to reenfranchise it, you'll need to mild editing to ChangeList method #changeListMenu:"
	
	| code block |
	code := UIManager default request: 'selection criteria for a change named aChangeRecord?\For instance, ''aChangeRecord category = ''System-Network''''' withCRs.
	code isEmptyOrNil ifTrue: [^ self ].
	block := EvaluateRequest evaluate: '[:aChangeRecord | ', code, ']'.
	self selectSuchThat: block! !

!ClassDescription methodsFor: '*Compiler-Extensions' stamp: 'EstebanAllende 4/3/2013 14:40'!
compile: text classified: category withStamp: changeStamp notifying: requestor logSource: logSource

	| methodAndNode |

	methodAndNode := self
		compile: text asString 
		classified: category
		notifying: requestor
		trailer: self defaultMethodTrailer 
		ifFail: [ ^ nil ].
		
	logSource ifTrue: [
		self 
			logMethodSource: methodAndNode node sourceCode 
			forMethodWithNode: methodAndNode
			inCategory: category 
			withStamp: changeStamp 
			notifying: requestor ].

	methodAndNode results do: [ :pair|		
		self 
			addAndClassifySelector: pair selector 
			withMethod: pair method 
			inProtocol: category 
			notifying: requestor.
	
		self instanceSide 
			noteCompilationOf: pair selector 
			meta: self isClassSide. 
	].
	^ methodAndNode selector! !
SHTextStylerST80 initialize!
